viewer.mode = OVERLAY

function setup()
    --make a table for globals, to keep track of 'em
    G = {}

    --set up scene
    G.scene = craft.scene()
    viewer = G.scene.camera:add(OrbitViewer, vec3(5,5,0), 20, 1, 100)
    G.scene.ambientColor = color(255, 39)
    G.scene.sun.rotation = quat.eulerAngles(25, 125, 0)
    
    --create a volume
    G.volume = G.scene:entity():add(craft.volume, 10, 10, 10)
    G.sizeX, G.sizeY, G.sizeZ = G.volume:size() 
    
    --make grid walls  
    G.grids = 
    {
        bottom = SingleGrid(G.scene, viewer.entity, vec3(0,1,0), vec3(0,0,0), 1, vec3(G.sizeX,G.sizeY,G.sizeZ), true),
        top = SingleGrid(G.scene, viewer.entity, vec3(0,-1,0), vec3(0,G.sizeY,0), 1, vec3(G.sizeX,G.sizeY,G.sizeZ), true),
        left = SingleGrid(G.scene, viewer.entity, vec3(1,0,0), vec3(0,0,0), 1, vec3(G.sizeX,G.sizeY,G.sizeZ), true),
        right = SingleGrid(G.scene, viewer.entity, vec3(-1,0,0), vec3(G.sizeX,0,0), 1, vec3(G.sizeX,G.sizeY,G.sizeZ), true),
        front = SingleGrid(G.scene, viewer.entity, vec3(0,0,1), vec3(0,0,0), 1, vec3(G.sizeX,G.sizeY,G.sizeZ), true),
        back = SingleGrid(G.scene, viewer.entity, vec3(0,0,-1), vec3(0,0,G.sizeZ), 1, vec3(G.sizeX,G.sizeY,G.sizeZ), true) 
    }
    --set up voxel drawing tool
    G.tool = OmniTool(G.scene, G.volume, G.grids, viewer.camera)

end



function update(dt) 
    G.scene:update(dt)
    for k,v in pairs(G.grids) do
        v:update()
    end
end

-- Perform 2D drawing (UI)
function draw()
    update(DeltaTime)
    G.scene:draw()
end

function touched(touch)
    G.tool:touched(touch)
    touches.touched(touch)
end